Subject: Re: bug#36937: 26.1; Sending mails doesn't set From: correctly

From: Sven Joachim <[email-masked]>
Date: Tue, 06 Aug 2019 10:34:41 +0200

On 2019-08-06 03:32 -0400, Stefan Monnier wrote:

>>>> This problem started happening in builds from master around 4 days ago:
>>>>
>>>> - start emacs -Q
>>>> - M-x mail (or any other form of sending email)
>>>> - Set a From: value different from user@localhostname
>>>> - Send mail using local sendmail
>>>>
>>>> The mail is sent with a from header seen by postfix (i don't know about
>>>> other MTAs) as user@localhost, instead of the From: i set in the
>>>> headers.  By user@localhost i mean the unix username running emacs and
>>>> the hostname as returned by hostname(1).  It seems emacs is just
>>>> ignoring the value of From:, or setting it in a way postfix doesn't
>>>> understand.
>>>>
>>>> I know almost for sure it's an emacs problem because emacs 26 or an
>>>> earlier version of emacs-snapshot is working without problems.
>>>
>>> Confirmed here, although it did not prevent me personally from sending
>>> mail, since I had already set up postfix to rewrite such
>>> user@localhostname addresses back.
>>>
>>> Reverting commit 3a59cc840693 (" * lisp/gnus/message.el: Reduce
>>> redundancy with send-mail-function") fixed the problem.  It looks like
>>> this commit changed some important options and looks NEWS-worthy.
>>
>> Most notably, it changed the default of message-sendmail-f-is-evil,
>> which is now t.
>
> Indeed, I aligned it with mail-specify-envelope-from.
> I guess I should revert this part.  But I'm still perplexed: `M-x mail`
> shouldn't pay any attention to message-sendmail-f-is-evil when sending
> the message.

Oh, I think it actually does not.  I almost always use Gnus, or
otherwise C-x m aka compose-mail which uses message-mode.  With
M-x mail, message-sendmail-f-is-evil does not seem to have an effect,
postfix always sees the user@localhost address then.  And this is even
the case in the emacs-26 branch.

Jose, did you actually use "M-x mail", or did you use something else
which uses message-mode to compose and send the mail?

Cheers,
       Sven